package eu.etaxonomy.taxeditor.prototype2.view;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import eu.etaxonomy.taxeditor.prototype2.Activator;

public class RelatedNameViewer extends NameViewer_ {

	Control ctlChooseRelType;
	
	RelatedNameViewer(TaxonName taxonName, DataBindingContext bindingContext,
			Composite parent) {
		super(taxonName, bindingContext, parent);
		setViewerLayout();
	}
	
	private void setViewerLayout() {
		
		ctlChooseRelType = new Label(parent, SWT.NONE);
		ctlChooseRelType.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		ctlChooseRelType.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		((Label) ctlChooseRelType).setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/unknown_no_bg.gif"));
		
		styledText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		styledText.setFont(SWTResourceManager.getFont("Georgia", 10, SWT.NONE));
		styledText.setIndent(12);
	}

	public Control getCtlChooseRelType() {
		return ctlChooseRelType;
	}

}
