/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.actions.name;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;

import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.ITaxEditorConstants;
import eu.etaxonomy.taxeditor.TaxEditorPlugin;
import eu.etaxonomy.taxeditor.controller.EditorController;
import eu.etaxonomy.taxeditor.controller.GlobalController;
import eu.etaxonomy.taxeditor.editor.name.CdmParserController;
import eu.etaxonomy.taxeditor.model.CdmSessionDataRepository;

/**
 * @author n.hoffmann
 * @created 02.02.2009
 * @version 1.0
 */
public class CreateTaxonomicallyIncludedTaxonAction extends Action {
	private static final Logger logger = Logger
			.getLogger(CreateTaxonomicallyIncludedTaxonAction.class);

	private static String text = "Create taxonomically included taxon";
	private static ImageDescriptor image = TaxEditorPlugin.getDefault()
			.getImageRegistry().getDescriptor(ITaxEditorConstants.BLACK_SQUARE_ICON);

	public CreateTaxonomicallyIncludedTaxonAction(){
		super(text, image);
	}
	
	public void run(){
		
		Taxon taxon = EditorController.getActiveEditor().getTaxon();
		// Create a new taxon with an empty name
		TaxonNameBase childName = 
				CdmParserController.parseFullReference("", null, null);
		Taxon childTaxon = Taxon.NewInstance(childName, CdmSessionDataRepository.getDefault().getDefaultSec());
				
		// Add the newly created taxon to the actual open taxon
		taxon.addTaxonomicChild(childTaxon, null, null);
		
		// Open a new editor window for the new taxon
		EditorController.open(childTaxon);
	}
}
