/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.IManagedForm;

import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
import eu.etaxonomy.cdm.model.description.Feature;
import eu.etaxonomy.cdm.model.description.TaxonDescription;
import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonRelationship;

/** 
 * @author p.ciardelli
 * @created 08.01.2009
 * @version 1.0
 */
public interface IFreeTextElementFactory {

	/* Taxon name editor elements */
	
	public Composite createAcceptedTaxon(IManagedForm form, Taxon taxon);
	
	public Composite createSynonym(Taxon taxon, Synonym synonym);

	public Composite createMisappliedName(Taxon taxon, Taxon misappliedName);
	
	public Composite createHomotypicalGroup(Taxon taxon, HomotypicalGroup group);
	
	public Composite createMisappliedGroup(Taxon taxon);
	
	public Composite createConceptGroup(Taxon taxon);

	public Composite createConcept(Taxon taxon, TaxonRelationship relationship);
	
	/* Taxon description editor elements */
	
	public Composite createDescriptionLabel(IManagedForm form, Taxon taxon, TaxonDescription description);
	
	public Composite createDescriptionElement(Taxon taxon, TaxonDescription description, DescriptionElementBase element);
	
	public Composite createDescriptionGroup(Taxon taxon, TaxonDescription description);
	
	public Composite createDescriptionFeatureGroup(Taxon taxon, TaxonDescription description, Feature feature);

}
