/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.ui.IWorkbenchActionConstants;
import org.eclipse.ui.part.EditorActionBarContributor;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.cdm.model.taxon.TaxonRelationshipType;
import eu.etaxonomy.taxeditor.actions.name.CreateAutonymAction;
import eu.etaxonomy.taxeditor.actions.name.CreateConceptRelationAction;
import eu.etaxonomy.taxeditor.actions.name.CreateHeterotypicSynonymAction;
import eu.etaxonomy.taxeditor.actions.name.CreateMisappliedNameAction;
import eu.etaxonomy.taxeditor.actions.name.CreateSynonymInGroupAction;
import eu.etaxonomy.taxeditor.actions.name.CreateTaxonomicallyIncludedTaxonAction;
import eu.etaxonomy.taxeditor.actions.ui.ChangeTaxonToSynonymAction;
import eu.etaxonomy.taxeditor.actions.ui.MoveTaxonDialogAction;
import eu.etaxonomy.taxeditor.model.CdmSessionDataRepository;

/**
 * @author n.hoffmann
 * @created 03.02.2009
 * @version 1.0
 */
public class MultiPageTaxonEditorActionBarContributor extends
		EditorActionBarContributor {
	private static final Logger logger = Logger
			.getLogger(MultiPageTaxonEditorActionBarContributor.class);

	/**
	 * 
	 */
	public MultiPageTaxonEditorActionBarContributor() {
		logger.warn("Setting up action bar contributions.");
	}
	
	public void contributeToMenu(IMenuManager menubar){		
		menubar.insertAfter(IWorkbenchActionConstants.M_EDIT, MenuConstants.EDITOR_TAXON_MENU());
	}
}
