/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.propertysheet;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.eclipse.jface.text.ITextViewer;
import org.eclipse.jface.text.contentassist.CompletionProposal;
import org.eclipse.jface.text.contentassist.ICompletionProposal;
import org.eclipse.jface.text.contentassist.IContentAssistProcessor;
import org.eclipse.jface.text.contentassist.IContextInformation;
import org.eclipse.jface.text.contentassist.IContextInformationValidator;

import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.taxeditor.model.CdmUtil;

/**
 * @author p.ciardelli
 * @created 19.05.2008
 * @version 1.0
 */
public class CompletionProcessor implements IContentAssistProcessor {
	private static final Logger logger = Logger
			.getLogger(CompletionProcessor.class);

	/* (non-Javadoc)
	 * @see org.eclipse.jface.text.contentassist.IContentAssistProcessor#computeCompletionProposals(org.eclipse.jface.text.ITextViewer, int)
	 */
	public ICompletionProposal[] computeCompletionProposals(
			ITextViewer viewer, int documentOffset) {
		String context = "Describe formatting / parsing of this rel. type.";
//			Image img = ResourceManager.getPluginImage(Activator.getDefault(), "icons/unknown.gif");
//		ICompletionProposal[] result =
//			new ICompletionProposal[myProposals.length];
//		for (int i = 0; i < myProposals.length; i++) {
//		      IContextInformation contextInfo = 
//			         new ContextInformation(null, myProposals[i]+" Style");
//			result[i] = new CompletionProposal(myProposals[i],documentOffset, 0, 
//					myProposals[i].length(), ResourceManager.getPluginImage(Activator.getDefault(), myIcons[i]), 
//					myProposals[i], contextInfo, context);
//
//		}
//		return result;
		String searchText = viewer.getTextWidget().getText() + "%";
//		List<TaxonNameBase> names = CdmUtil.getNameByName(searchText);
		List<TaxonNameBase> names = null;
		logger.warn(names.size() + " names");
		List<ICompletionProposal> proposals = new ArrayList<ICompletionProposal>();
//		String[] test = new String[] {"suggestion 1", "suggestion 2", "suggestion 3"};
		for (TaxonNameBase name : names) {
			String proposalText = name.getTitleCache();
//		for (String proposalText : test) {
			proposals.add(new CompletionProposal(proposalText,
					0,
					searchText.length(),
					proposalText.length(),
					null,
					proposalText,
					null,
					null
					));
		}		
		logger.warn(proposals.size() + " proposals.");
		return proposals.toArray(new ICompletionProposal[proposals.size()]);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.text.contentassist.IContentAssistProcessor#computeContextInformation(org.eclipse.jface.text.ITextViewer, int)
	 */
	public IContextInformation[] computeContextInformation(ITextViewer viewer,
			int offset) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.text.contentassist.IContentAssistProcessor#getCompletionProposalAutoActivationCharacters()
	 */
	public char[] getCompletionProposalAutoActivationCharacters() {
		return new char[] {'a','b','c','d','e','f','g','H'};
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.text.contentassist.IContentAssistProcessor#getContextInformationAutoActivationCharacters()
	 */
	public char[] getContextInformationAutoActivationCharacters() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.text.contentassist.IContentAssistProcessor#getContextInformationValidator()
	 */
	public IContextInformationValidator getContextInformationValidator() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.text.contentassist.IContentAssistProcessor#getErrorMessage()
	 */
	public String getErrorMessage() {
		// TODO Auto-generated method stub
		return null;
	}
}